/**
 * Copyright (C) 2012 Matt McDonald.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @see http://www.fortybelow.ca/projects/JavaScript/Utils/
 */

var Utils=Utils||{},global=this;if(typeof Utils==="object"&&Utils){(function(){var e={INDEX_SIZE_ERROR:"The index is not in the allowed range.",HEIRARCHY_REQUEST_ERROR:"The operation would yield an incorrect node tree.",WRONG_DOCUMENT_ERROR:"The object is in the wrong document.",INVALID_CHARACTER_ERROR:"The string contains invalid characters.",NO_MODIFICATION_ALLOWED_ERROR:"The object can not be modified.",NOT_FOUND_ERROR:"The object can not be found here.",NOT_SUPPORTED_ERROR:"The operation is not supported.",INVALID_STATE_ERROR:"The object is in an invalid state.",SYNTAX_ERROR:"The string did not match the expected pattern.",INVALID_MODIFICATION_ERROR:"The object can not be modified in this way.",NAMESPACE_ERROR:"The operation is not allowed by Namespaces in XML.",INVALID_ACCESS_ERROR:"The object does not support the operation or argument.",TYPE_MISMATCH_ERROR:"The type of the object does not match the expected type.",SECURITY_ERROR:"The operation is insecure.",NETWORK_ERROR:"A network error occurred.",ABORT_ERROR:"The operation was aborted.",URL_MISMATCH_ERROR:"The given URL does not match another URL.",QUOTA_EXCEEDED_ERROR:"The quota has been exceeded.",TIMEOUT_ERROR:"The operation timed out.",INVALID_NODE_TYPE_ERROR:"The supplied node is incorrect or has an incorrect ancestor for this operation.",DATA_CLONE_ERROR:"The object can not be cloned."};function c(){throw new Error(e.INDEX_SIZE_ERROR)}function k(){throw new Error(e.HEIRARCHY_REQUEST_ERROR)}function f(){throw new Error(e.WRONG_DOCUMENT_ERROR)}function h(){throw new Error(e.INVALID_CHARACTER_ERROR)}function o(){var w="NO_MODIFICATION_ALLOWED_ERROR";throw new Error(e[w])}function b(){throw new Error(e.NOT_FOUND_ERROR)}function p(){throw new Error(e.NOT_SUPPORTED_ERROR)}function i(){throw new Error(e.INVALID_STATE_ERROR)}function n(){throw new Error(e.SYNTAX_ERROR)}function m(){throw new Error(e.INVALID_MODIFICATION_ERROR)}function s(){throw new Error(e.NAMESPACE_ERROR)}function r(){throw new Error(e.INVALID_ACCESS_ERROR)}function v(){throw new Error(e.TYPE_MISMATCH_ERROR)}function u(){throw new Error(e.SECURITY_ERROR)}function a(){throw new Error(e.NETWORK_ERROR)}function l(){throw new Error(e.ABORT_ERROR)}function q(){throw new Error(e.URL_MISMATCH_ERROR)}function g(){throw new Error(e.QUOTA_EXCEEDED_ERROR)}function j(){throw new Error(e.TIMEOUT_ERROR)}function d(){throw new Error(e.INVALID_NODE_TYPE_ERROR)}function t(){throw new Error(e.DATA_CLONE_ERROR)}Utils.raise=Utils.raise||{types:e,indexSize:c,heirarchyRequest:k,wrongDocument:f,invalidCharacter:h,noModificationAllowed:o,notFound:b,notSupported:p,invalidState:i,syntax:n,invalidModification:m,namespace:s,invalidAccess:r,typeMismatch:v,security:u,network:a,abort:l,urlMismatch:q,quotaExceeded:g,timeout:j,invalidNodeType:d,dataClone:t}}())}if(typeof Utils==="object"&&Utils){(function(){Utils.types=Utils.types||{ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12}}())}if(typeof Utils==="object"&&Utils){(function(){var m,B,C,i,c,b,y;m={object:true,"function":true};function e(G){var E=typeof G,F=m[E]&&G;return !!(F||E==="unknown")}function f(H){var F=typeof H,G=m[F]&&H,E=false;if(G||F==="unknown"){E=typeof H.length==="number"}return E}function d(H){var F=typeof H,G=m[F]&&H,E=false;if(G||F==="unknown"){E=typeof H.nodeType==="number"}return E}function D(I,F){var G=typeof I,H=m[G]&&I,E=false;if(H||G==="unknown"){E=I.nodeType===F}return E}B={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};function q(F){var E=B.ELEMENT_NODE;return D(F,E)}function l(F){var E=B.ATTRIBUTE_NODE;return D(F,E)}function j(F){var E=B.TEXT_NODE;return D(F,E)}function t(F){var E=B.CDATA_SECTION_NODE;return D(F,E)}function z(G){var E="ENTITY_REFERENCE_NODE",F=B[E];return D(G,F)}function s(F){var E=B.ENTITY_NODE;return D(F,E)}function a(G){var E="PROCESSING_INSTRUCTION_NODE",F=B[E];return D(G,F)}function w(F){var E=B.COMMENT_NODE;return D(F,E)}function k(F){var E=B.DOCUMENT_NODE;return D(F,E)}C=global.document;function v(E){return E===global.document}i=(function(){var E=k;if(!d(C)){E=v}return E}());function A(F){var E=B.DOCUMENT_TYPE_NODE;return D(F,E)}function g(G){var E="DOCUMENT_FRAGMENT_NODE",F=B[E];return D(G,F)}function p(F){var E=B.NOTATION_NODE;return D(F,E)}function o(E){return E===global.window}function h(F){var E="document";if(e(F[E])){return F[E]}F=null;return null}c=(function(){var E="parentWindow";return e(C[E])}());function x(F){var E="parentWindow";if(e(F[E])){return F[E]}F=null;return null}b=(function(){var E="defaultView";return e(C[E])}());function u(F){var E="defaultView";if(e(F[E])){return F[E]}F=null;return null}function r(E){return E===x(h(E)||global.document)}function n(E){return E===u(h(E)||global.document)}y=(function(){var E=o;if(c){E=r}else{if(b){E=n}}return E}());C=null;Utils.is=Utils.is||{hostObject:e,arrayLike:f,nodeLike:d,nodeType:D,element:q,attribute:l,text:j,cDataSection:t,entityReference:z,entity:s,processingInstruction:a,comment:w,document:i,documentType:A,documentFragment:g,notation:p,window:y}}())}if(typeof Utils==="object"&&Utils){(function(){var r,q,m;r={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};q=(function(){var s={};s[r.TEXT_NODE]=true;s[r.PROCESSING_INSTRUCTION_NODE]=true;s[r.COMMENT_NODE]=true;return s}());m={object:true,"function":true};function h(v){var t=typeof v,u=m[t]&&v,s=false;if(u||t==="unknown"){s=typeof v.length==="number"}return s}function f(v){var t=typeof v,u=m[t]&&v,s=false;if(u||t==="unknown"){s=typeof v.nodeType==="number"}return s}function g(u){var s=typeof u,t=m[s]&&u;return !!(t||s==="unknown")}function d(w,t,v){var u="insertBefore",s=null;if(f(w)&&f(t)&&f(v)){if(g(w[u])){s=w[u](t,v)}}return s}function k(w,x,v){var u,t,y,s;if(h(x)){u=x.length-1;for(t=u;t>-1;t-=1){y=u-t;d(w,x[y],v)}}return s}function l(u,v){var t="appendChild",s=null;if(f(u)&&f(v)){if(g(u[t])){s=u[t](v)}}return s}function e(v,w){var u,t,x,s;if(h(w)){u=w.length-1;for(t=u;t>-1;t-=1){x=u-t;l(v,w[x])}}return s}function i(u,v){var t="removeChild",s=null;if(f(u)&&f(v)){if(g(u[t])){s=u[t](v)}}return s}function p(w,u,t){var v="replaceChild",s=null;if(f(w)&&f(u)&&f(t)){if(g(w[v])){s=w[v](u,t)}}return s}function o(v,t){var u="cloneNode",s=null;if(f(v)){if(g(v[u])){s=v[u](v,t)}}return s}function c(t){var s=false;if(f(t)){s=typeof t.nodeName==="string"}return s}function n(w,u){var v="toLowerCase",t="toUpperCase",s=null;if(c(w)){s=w.nodeName;if(u){s=s[v]()}else{if(!u){s=s[t]()}}}return s}function j(t){var s=false;if(f(t)){s=typeof t.nodeValue==="string"}return s}function b(t){var s=null;if(j(t)){s=t.nodeValue}return s}function a(v,u){var t="nodeValue",s=null;if(f(v)){if(q[v.nodeType]){s=v[t]=u}}return s}Utils.node=Utils.node||{prepend:d,prependList:k,append:l,appendList:e,remove:i,replace:p,clone:o,getName:n,getValue:b,setValue:a}}())}if(typeof Utils==="object"&&Utils){(function(){var h,k,f,a,j,n,i,b,q,p;h={object:true,"function":true};function e(t){var r=typeof t,s=h[r]&&t;return !!(s||r==="unknown")}k=global.document;function o(t,r){var s="createElement";return t[s](r)}f=(function(){var s="createElement",r=null;if(e(k[s])){r=o}return r}());function d(u,t,r){var s="createElementNS";return u[s](t,r)}a=(function(){var s="createElementNS",r=null;if(e(k[s])){r=d}return r}());function c(s,t){var r="createTextNode";return s[r](t)}j=(function(){var s="createTextNode",r=null;if(e(k[s])){r=c}return r}());function m(t,s,u){var r="createProcessingInstruction";return t[r](s,u)}n=(function(){var s="createProcessingInstruction",r=null;if(e(k[s])){r=m}return r}());function g(s,t){var r="createComment";return s[r](t)}i=(function(){var s="createComment",r=null;if(e(k[s])){r=g}return r}());b=(function(){var s="createDocumentFragment",r=false;if(e(k[s])){r=true}return r}());q=(function(){var s="createDocumentFragment",r=b;if(b){try{k[s]()}catch(t){r=false}}return r}());function l(s){var r="createDocumentFragment";return s[r]()}p=(function(){var r=null;if(q){r=l}return r}());k=null;Utils.create=Utils.create||{element:f,elementNS:a,text:j,processingInstruction:n,comment:i,documentFragment:p}}())}if(typeof Utils==="object"&&Utils){(function(){var G,l,D,R,F,k,X,ac,W,Q,H,s,w,ae,e,z,n,K;G={" ":true,"\t":true,"\n":true,"\f":true,"\r":true};l=global.document;D=(function(){var af=null;if(l&&l.body){af=l.body}return af}());R={object:true,"function":true};F={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};function c(aj,ag){var ah=typeof aj,ai=R[ah]&&aj,af=false;if(ai||ah==="unknown"){af=aj.nodeType===ag}return af}function ab(ag){var af=F.ELEMENT_NODE;return c(ag,af)}k=(function(){var af=false;if(ab(D)){af=typeof D.className==="string"}return af}());function J(ah){var af=typeof ah,ag=R[af]&&ah;return !!(ag||af==="unknown")}X=(function(){var af=false;if(ab(D)){af=J(D.classList)}return af}());function f(ai,ah){var ag=ai,af=ah;return function(ak,aj){if(ab(ak)){af=ak.classList[ag](aj)}return af}}ac=(function(){var ag="contains",af=null;if(D&&X&&J(D.classList[ag])){af=f(ag,"false")}return af}());function j(){throw new Error("The string contains invalid characters.")}function B(){throw new Error("The string did not match the expected pattern.")}function r(ai){var ah=G[ai],ag="undefined",af=false;if(ai===""){B()}else{if(ah!==global[ag]){j()}else{if(ah===global[ag]){af=true}}}return af}function v(ai){var ah=0,ag,af=true;if(ai&&ai.length){ag=ai.length;for(ah;ah<ag;ah+=1){af=r(ai.charAt(ah))}}return af}function U(ah,aj,ai){var ag=false,af="";if(ah&&ah!==" "){ag=r(ah)}if(!ag&&aj.length){ai[ai.length]=aj}else{if(ag){af=aj+ah}}return af}function d(ai){var ah=0,ag,aj="",af=[];if(ai&&ai.length){ag=ai.length+1;for(ah;ah<ag;ah+=1){aj=U(ai.charAt(ah),aj,af)}}return af}function A(ag){var af=[];if(k){af=d(ag.className)}return af}function O(ai,aj){var ah=0,ag,af=false;ag=ai.length;for(ah;ah<ag;ah+=1){if(aj===ai[ah]){af=true;break}}return af}function L(ah,ag){var af=false;if(v(ag)){af=O(ah,ag)}return af}function p(ah,ag){var af=null;if(ab(ah)){af=L(A(ah),ag)}return af}W=(function(){var af=null;if(X){af=ac}else{if(!X&&ab(D)){af=p}}return af}());function b(ah,ag){var af=null;if(W){af=W(ah,ag)}return af}function C(aj,ai){var ah=0,ag=ai.length,af=true;while(ah<ag&&af){af=b(aj,ai[ah]);af=!!af;ah+=1}return af}function N(ai){var ag=typeof ai,ah=R[ag]&&ai,af=false;if(ah||ag==="unknown"){af=typeof ai.length==="number"}return af}function a(ah,ag){var af=false;if(ab(ah)){if(N(ag)){af=C(ah,ag)}}return af}Q=(function(){var af=null;if(D&&X&&J(D.classList.add)){af=f("add")}return af}());function h(ai,ah,ag){var af=false;if(!b(ai,ah)){ag[ag.length]=ah;af=true}return af}function T(ai,ag,ah){var af=false;if(v(ag)){af=h(ai,ag,ah)}return af}function Y(ah,ag){var af;if(k){ah.className=ag.join(" ")}return af}function i(ai,ag){var ah,af;if(ab(ai)){ah=A(ai);T(ai,ag,ah);Y(ai,ah)}return af}H=(function(){var af=null;if(X){af=Q}else{if(!X&&ab(D)){af=i}}return af}());function S(ah,ag){var af=null;if(H){af=H(ah,ag)}return af}function m(aj,ai){var ah=0,ag=ai.length,af;for(ah;ah<ag;ah+=1){S(aj,ai[ah])}return af}function P(ah,ag){var af;if(ab(ah)){if(N(ag)){m(ah,ag)}}return af}s=(function(){var ag="remove",af=null;if(D&&X&&J(D.classList[ag])){af=f(ag)}return af}());function y(ai,al){var ah=al.length-1,ag=ah,am,ak=0,aj,af;for(ag;ag>-1;ag-=1){am=ah-ag;aj=al[am];if(aj===ai){delete al[am]}else{if(aj!==ai){delete al[am];al[ak]=aj;ak+=1}}}al.length=ak;return af}function ad(ai,ag,ah){var af;if(b(ai,ag)){af=y(ag,ah)}return af}function u(ai,ag,ah){var af;if(v(ag)){ad(ai,ag,ah)}return af}function g(ai,ag){var ah,af;if(ab(ai)){ah=A(ai);u(ai,ag,ah);Y(ai,ah)}return af}w=(function(){var af=null;if(X){af=s}else{if(!X&&ab(D)){af=g}}return af}());function M(ah,ag){var af=null;if(w){af=w(ah,ag)}return af}function I(ak,aj){var ah=aj.length,ag=ah,ai,af;for(ag;ag>-1;ag-=1){ai=ah-ag;M(ak,aj[ai])}return af}function o(ah,ag){var af;if(ab(ah)){if(N(ag)){I(ah,ag)}}return af}ae=(function(){var ag="toggle",af=null;if(D&&X&&J(D.classList[ag])){af=f(ag,"false")}return af}());function V(ai,ah){var ag=b(ai,ah),af=false;if(!ag){S(ai,ah);af=true}else{if(ag){M(ai,ah)}}return af}e=(function(){var af=null;if(l){if(X){af=ae}else{if(!X&&ab(D)){af=V}}}return af}());function x(ah,ag){var af=null;if(e){af=e(ah,ag)}return af}function aa(aj,ai){var ah=0,ag=ai.length,af;for(ah;ah<ag;ah+=1){x(aj,ai[ah])}return af}function E(ah,ag){var af;if(ab(ah)){if(N(ag)){aa(ah,ag)}}return af}z=(function(){var af=null;if(D&&X&&J(D.classList.item)){af=f("item",null)}return af}());function q(ai,ag){var ah,af=null;if(ab(ai)){ah=A(ai);if(ag>=0&&ag<ah.length){af=ah[ag]}}return af}n=(function(){var af=null;if(l){if(X){af=z}else{if(!X&&ab(D)){af=q}}}return af}());function t(aj){var ah,ag,ai,af=[];if(N(aj)){af.length=aj.length;ah=aj.length-1;for(ag=ah;ag>-1;ag-=1){ai=ah-ag;af[ai]=aj[ai]}}return af}function Z(ag){var af=null;if(ab(ag)){af=t(ag.classList)}return af}K=(function(){var af=null;if(D){if(X){af=Z}else{if(!X&&ab(D)){af=A}}}return af}());l=null;D=null;Utils.classes=Utils.classes||{contains:W,containsList:a,add:H,addList:P,remove:w,removeList:o,toggle:e,toggleList:E,item:n,get:K}}())}if(typeof Utils==="object"&&Utils){(function(){var d,D,n,k,c;d=global.document;D={object:true,"function":true};function j(P){var N=typeof P,O=D[N]&&P,M=false;if(O||N==="unknown"){M=typeof P.nodeType==="number"}return M}function v(O){var M=typeof O,N=D[M]&&O;return !!(N||M==="unknown")}function x(P){var N=typeof P,O=D[N]&&P,M=false;if(O||N==="unknown"){M=typeof P.length==="number"}return M}function m(Q){var O,N,P,M=[];if(x(Q)){M.length=Q.length;O=Q.length-1;for(N=O;N>-1;N-=1){P=O-N;M[P]=Q[P]}}return M}function z(O){var N="childNodes",M=null;if(j(O)){if(v(O[N])){M=m(O[N])}}return M}c=(function(){var N="childNodes",M=null;if(v(d[N])){M=z}return M}());function I(O,P,M){var N;if(typeof P==="function"){N=P(O);if(N===true){M[M.length]=O}else{if(N){M[M.length]=N}}}}function g(Q,R){var O,N,P,M=[];if(x(Q)){O=Q.length-1;for(N=O;N>-1;N-=1){P=O-N;I(Q[P],R,M)}}return M}function B(N){var M=null;if(c){M=c(N)}return M}function o(N,O){var M=[];if(typeof O==="function"){M=g(B(N),O)}return M}function f(O,P){var N="removeChild",M=null;if(j(O)&&j(P)){if(v(O[N])){M=O[N](P)}}return M}function i(N){var M=null;if(j(N)){f(N.parentNode,N)}return M}function K(N){var M=null;if(j(N)){M=o(N,i)}return M}n={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};function a(Q,N){var O=typeof Q,P=D[O]&&Q,M=false;if(P||O==="unknown"){M=Q.nodeType===N}return M}function J(N){var M=n.ELEMENT_NODE;return a(N,M)}function b(N){var M=false;if(J(N)){M=true}return M}function t(M){return g(B(M),b)}function G(O){var N="children",M=null;if(J(O)){if(v(O[N])){M=m(O[N])}}return M}function E(N){var M=false;if(J(N)){M=v(N.children)}return M}k=(function(){var N,M;if(d){N=E(d.body);M=t;if(N){M=G}}return M}());function w(N){var M=null;if(k){M=k(N)}return M}function y(N,O){var M=[];if(typeof O==="function"){M=g(w(N),O)}return M}function s(N){var M=false;if(J(N)){M=i(N)}return M}function l(N){var M=null;if(j(N)){M=y(N,s)}return M}function F(P,N,O){var M;O[O.length]=P;if(N.length){O[O.length]=N}return M}function q(N){var M=false;if(j(N)){M=v(N.childNodes)}return M}function e(R){var P,O,Q,N,M=[];if(q(R)){P=R.childNodes.length-1;for(O=P;O>-1;O-=1){Q=P-O;N=e(R.childNodes[Q]);F(R.childNodes[Q],N,M)}}return M}function H(O){var N="childNodes",M=null;if(j(O)){if(v(O[N])){M=e(O)}}return M}function p(Q,R,O){var N,M,P;O=O||[];if(q(Q)){N=Q.childNodes.length-1;for(M=N;M>-1;M-=1){P=N-M;p(Q.childNodes[P],R,O);I(Q.childNodes[P],R,O)}}return O}function u(Q,R,O){var N,M,P;O=O||[];if(x(Q)){N=Q.length-1;for(M=N;M>-1;M-=1){P=N-M;u(Q[P],R,O);I(Q[P],R,O)}}return O}function L(O,N,P){var M;if(J(O)){F(O,N,P)}return M}function A(R){var P,O,Q,N,M=[];if(q(R)){P=R.childNodes.length-1;for(O=P;O>-1;O-=1){Q=P-O;N=A(R.childNodes[Q]);L(R.childNodes[Q],N,M)}}return M}function C(O){var N="childNodes",M=null;if(j(O)){if(v(O[N])){M=A(O)}}return M}function h(N,P,O){var M;if(J(N)){I(N,P,O)}return M}function r(Q,R,O){var N,M,P;O=O||[];if(q(Q)){N=Q.childNodes.length-1;for(M=N;M>-1;M-=1){P=N-M;r(Q.childNodes[P],R,O);h(Q.childNodes[P],R,O)}}return O}d=null;Utils.traverse=Utils.traverse||{getNodes:c,linear:g,nodes:o,clearNodes:K,getElements:k,elements:y,clearElements:l,getNodeTree:H,nodeTree:p,recursive:u,getElementTree:C,elementTree:r}}())}if(typeof Utils==="object"&&Utils){(function(){var G,u,F,b,B,z,C,c,E;G=global.document;u={object:true,"function":true};function i(L){var J=typeof L,K=u[J]&&L,I=false;if(K||J==="unknown"){I=typeof L.nodeType==="number"}return I}function j(K){var I=typeof K,J=u[I]&&K;return !!(J||I==="unknown")}function r(K,L,I){var J;if(typeof L==="function"){J=L(K);if(J===true){I[I.length]=K}else{if(J){I[I.length]=J}}}}function l(K,L){var J="removeChild",I=null;if(i(K)&&i(L)){if(j(K[J])){I=K[J](L)}}return I}function w(J){var I=null;if(i(J)){l(J.parentNode,J)}return I}function s(J){var I;if(i(J)){while(J.firstChild){w(J.firstChild)}}return I}F={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};b=(function(){var I={};I[F.ELEMENT_NODE]=true;I[F.TEXT_NODE]=true;I[F.PROCESSING_INSTRUCTION_NODE]=true;I[F.COMMENT_NODE]=true;I[F.DOCUMENT_FRAGMENT_NODE]=true;return I}());function y(K){var J=b,I=false;if(i(K)){if(J[K.nodeType]){I=true}}return I}function H(M,J){var K=typeof M,L=u[K]&&M,I=false;if(L||K==="unknown"){I=M.nodeType===J}return I}function v(J){var I=F.TEXT_NODE;return H(J,I)}function o(K){var J="nodeValue",I=null;if(i(K)){if(typeof K[J]==="string"){I=K[J]}}return I}function g(J){var I=null;if(v(J)){I=o(J)}return I}function e(I){return o(I)}function a(J){var I=false;if(i(J)){I=j(J.childNodes)}return I}function x(M,N,K){var J,I,L;K=K||[];if(a(M)){J=M.childNodes.length-1;for(I=J;I>-1;I-=1){L=J-I;x(M.childNodes[L],N,K);r(M.childNodes[L],N,K)}}return K}function k(K){var J,I=null;if(i(K)){J=x(K,g);I=J.join("")}return I}B=(function(){var I={};I[F.ELEMENT_NODE]=k;I[F.TEXT_NODE]=e;I[F.COMMENT_NODE]=e;I[F.DOCUMENT_FRAGMENT_NODE]=k;I[F.PROCESSING_INSTRUCTION_NODE]=e;return I}());function d(L){var K=B,J,I=null;if(y(L)){J=K[L.nodeType];if(typeof J==="function"){I=J(L)}}return I}z=(function(){var I={};I[F.ELEMENT_NODE]=true;I[F.TEXT_NODE]=true;I[F.PROCESSING_INSTRUCTION_NODE]=true;I[F.COMMENT_NODE]=true;I[F.DOCUMENT_FRAGMENT_NODE]=true;return I}());function p(K){var J=z,I=false;if(i(K)){if(J[K.nodeType]){I=true}}return I}function h(J,K){var I="createTextNode";return J[I](K)}C=(function(){var J="createTextNode",I=null;if(j(G[J])){I=h}return I}());function n(J,K){var I=null;if(C){I=C(J,K)}return I}function t(K,L){var J="appendChild",I=null;if(i(K)&&i(L)){if(j(K[J])){I=K[J](L)}}return I}function D(L,M,K){var J,I=null;J=n(K,M);I=t(L,J);return I}function f(K,M,J){var L,I=null;if(i(K)){s(K);L=D(K,M,J);I=o(L)}return I}function q(L,K){var J="nodeValue",I=null;if(i(L)){if(E[L.nodeType]){I=L[J]=K}}return I}E=(function(){var I={};I[F.TEXT_NODE]=true;I[F.PROCESSING_INSTRUCTION_NODE]=true;I[F.COMMENT_NODE]=true;return I}());function m(I,J){return q(I,J)}c=(function(){var I={};I[F.ELEMENT_NODE]=f;I[F.TEXT_NODE]=m;I[F.COMMENT_NODE]=m;I[F.DOCUMENT_FRAGMENT_NODE]=f;I[F.PROCESSING_INSTRUCTION_NODE]=m;return I}());function A(M,N,L){var K=c,J,I=null;if(p(M)){J=K[M.nodeType];if(typeof J==="function"){I=J(M,N,L)}}return I}G=null;Utils.text=Utils.text||{get:d,set:A}}())}if(typeof Utils==="object"&&Utils){(function(){var i,c;i=global.document;c={object:true,"function":true};function e(m){var k=typeof m,l=c[k]&&m,j=false;if(l||k==="unknown"){j=typeof m.nodeType==="number"}return j}function b(l){var j=typeof l,k=c[j]&&l;return !!(k||j==="unknown")}function f(l){var k="parent",j=null;if(e(l)){if(b(l.parentNode)){j={};j.value=l.parentNode;j[k]=f(l.parentNode)}}return j}function h(l,m){var k="parent",j=false;if(e(m)){while(l&&!j){j=l.value===m;l=l[k]}}return j}function a(k,m){var l,j=false;if(e(m)){l=f(m);j=h(l,k)}return j}function d(l,m,j){var k;if(typeof m==="function"){k=m(l);if(k===true){j[j.length]=l}else{if(k){j[j.length]=k}}}}function g(m,n){var l=f(m),k="parent",j=[];if(typeof n==="function"){while(l){d(l.value,n,j);l=l[k]}}return j}i=null;Utils.ancestors=Utils.ancestors||{get:f,is:a,traverse:g}}())}if(typeof Utils==="object"&&Utils){(function(){var i,O,A,v,w,r,g,o,b,R,Y,d,k,N,K,L,C,D,G,V,F,U,M,q,p,f,S,z;i=global.document;O={object:true,"function":true};function l(ag){var ae=typeof ag,af=O[ae]&&ag,ad=false;if(af||ae==="unknown"){ad=typeof ag.nodeType==="number"}return ad}function E(af){var ad=typeof af,ae=O[ad]&&af;return !!(ae||ad==="unknown")}function H(ag){var ae=typeof ag,af=O[ae]&&ag,ad=false;if(af||ae==="unknown"){ad=typeof ag.length==="number"}return ad}function m(ah){var af,ae,ag,ad=[];if(H(ah)){ad.length=ah.length;af=ah.length-1;for(ae=af;ae>-1;ae-=1){ag=af-ae;ad[ag]=ah[ag]}}return ad}function j(ae){var ad=ae;return function(ag,af){return m(ag[ad](af))}}A=(function(){var ae="getElementsByName",ad=null;if(E(i[ae])){ad=j(ae)}return ad}());v={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};function a(ah,ae){var af=typeof ah,ag=O[af]&&ah,ad=false;if(ag||af==="unknown"){ad=ah.nodeType===ae}return ad}function ac(ae){var ad=v.DOCUMENT_NODE;return a(ae,ad)}function u(ad){return ad===global.document}r=(function(){var ad=ac;if(!l(i)){ad=u}return ad}());function X(ae){var ad=v.ELEMENT_NODE;return a(ae,ad)}function x(ae){var ad=ae;return function(ah,ag){var af=null;if(r(ah)||X(ah)){af=m(ah[ad](ag))}return af}}w=(function(){var ae="getElementsByTagName",ad=null;if(E(i[ae])){ad=x(ae)}return ad}());function t(ae){var ad=ae;return function(ag,ah,ai){var af=null;if(r(ag)||X(ag)){af=m(ag[ad](ah,ai))}return af}}g=(function(){var ae="getElementsByTagNameNS",ad=null;if(E(i[ae])){ad=t(ae)}return ad}());function J(ae){var ad=ae;return function(ag,ah){var af=null;if(r(ag)||X(ag)){af=m(ag[ad](ah))}return af}}o=(function(){var ae="getElementsByClassName",ad=null;if(E(i[ae])){ad=J(ae)}return ad}());function T(ae){var ad=ae;return function(af,ag){return af[ad](ag)}}b=(function(){var ae="getElementById",ad=null;if(E(i[ae])){ad=T(ae)}return ad}());function B(ad){return ad.head}function ab(af){var ae,ad=null;ae=w(af,"head");if(H(ae)){ad=ae[0]}return ad}R=(function(){var ae="getElementsByTagName",ad=null;if(E(i.head)){ad=B}else{if(E(i[ae])){ad=ab}}return ad}());function P(ad){return ad.body}function h(af){var ae,ad=null;ae=w(af,"body");if(H(ae)){ad=ae[0]}return ad}Y=(function(){var ae="getElementsByTagName",ad=null;if(E(i.body)){ad=P}else{if(E(i[ae])){ad=h}}return ad}());d=(function(){var ad={};ad[v.ELEMENT_NODE]=true;ad[v.DOCUMENT_NODE]=true;ad[v.DOCUMENT_FRAGMENT_NODE]=true;return ad}());function s(ag){var af=d,ae="undefined",ad=false;if(l(ag)){ad=af[ag.nodeType]!==global[ae]}return ad}function e(ae){var ad=ae;return function(ag,ah){var af=null;if(s(ag)){af=ag[ad](ah)}return af}}k=(function(){var ae="querySelector",ad=null;if(s(i)){if(E(i[ae])){ad=e(ae)}}return ad}());function c(ae){var ad=ae;return function(ag,ah){var af=null;if(s(ag)){af=m(ag[ad](ah))}return af}}N=(function(){var ae="querySelectorAll",ad=null;if(s(i)){if(E(i[ae])){ad=c(ae)}}return ad}());function Q(ae){var ad=ae;if(!l(ae)&&H(ae)){ad=m(ae)}return ad}function I(ae){var ad=ae;return function(af){return m(af[ad])}}function W(af,ae){var ad=null;if(E(af[ae])){ad=I(ae)}return ad}function y(ae){var ad=ae;return function(ag,af){return Q(ag[ad][af])}}function aa(af,ae){var ad=null;if(E(af[ae])){ad=y(ae)}return ad}K=(function(){return aa(i,"images")}());L=(function(){return W(i,"images")}());C=(function(){return aa(i,"embeds")}());D=(function(){return W(i,"embeds")}());G=(function(){return aa(i,"links")}());V=(function(){return W(i,"links")}());F=(function(){return aa(i,"forms")}());U=(function(){return W(i,"forms")}());M=(function(){return aa(i,"scripts")}());q=(function(){return W(i,"scripts")}());p=(function(){return aa(i,"applets")}());f=(function(){return W(i,"applets")}());S=(function(){return aa(i,"anchors")}());z=(function(){return W(i,"anchors")}());function Z(ag,af,ae){var ad=null;if(ag&&E(ag[af])){ad=Q(ag[af][ae])}return ad}function n(af,ae){var ad=null;if(af&&E(af[ae])){ad=m(af[ae])}return ad}i=null;Utils.select=Utils.select||{byName:A,byTagName:w,byTagNameNS:g,byClassName:o,byId:b,query:k,queryAll:N,body:Y,head:R,images:K,allImages:L,embeds:C,allEmbeds:D,plugins:C,allPlugins:D,links:G,allLinks:V,forms:F,allForms:U,scripts:M,allScripts:q,applets:p,allApplets:f,anchors:S,allAnchors:z,namedItem:Z,collection:n}}())}if(typeof Utils==="object"&&Utils){Utils.event=Utils.event||{};Utils.event.these={};Utils.event.handlers={};(function(){var T,k,g,P,r,J,U,Y,j,C,z,d,E,i,R,w;T={object:true,"function":true};function M(ai){var ag=typeof ai,ah=T[ag]&&ai;return !!(ah||ag==="unknown")}k=global.document;g=typeof Function.prototype.call==="function";P=0;function V(ah){var ag="these";return Utils.event[ag][ah]}function f(ai){var ah="handlers",ag="unbound";return Utils.event[ah][ai][ag]}function A(ag){return function(ah){return f(ag).call(V(ag),ah)}}function K(ah){var ag=null;if(g){ag=A(ah);ag.handlerId=P;P+=1}return ag}function l(ak,ah){var aj="handlers",al=P,ai="these",ag="bound";Utils.event[aj][al]={unbound:ak,bound:K(al)};Utils.event[ai][al]=ah;ak=null;ah=null;return Utils.event[aj][al][ag]}function X(ai,ag){var ah="undefined";if(ai&&typeof ai==="function"){if(ai.handlerId===global[ah]){return l(ai,ag)}}ag=null;return ai}Utils.event.bindHandler=X;function x(al){var ak="event",ai="handlers",aj=Utils[ak][ai],ah="undefined",ag=false;if(aj[al]!==global[ah]){ag=delete aj[al]}aj=null;return ag}function m(al){var ak="event",ai="these",aj=Utils[ak][ai],ah="undefined",ag=false;if(aj[al]!==global[ah]){ag=delete aj[al]}aj=null;return ag}function H(ah){var ag;x(ah);m(ah);return ag}function e(ah){var ag=null;if(ah&&typeof ah==="function"){if(typeof ah.handlerId==="number"){ag=f(ah.handlerId);H(ah.handlerId)}}ah=null;return ag}Utils.event.unbindHandler=e;function W(ag){return ag===global}function I(ah){var ag="document";if(M(ah[ag])){return ah[ag]}ah=null;return null}r=(function(){var ag="parentWindow";return M(k[ag])}());function s(ah){var ag="parentWindow";if(M(ah[ag])){return ah[ag]}ah=null;return null}J=(function(){var ag="defaultView";return M(k[ag])}());function u(ah){var ag="defaultView";if(M(ah[ag])){return ah[ag]}ah=null;return null}function G(ag){return ag===s(I(ag)||global.document)}function D(ag){return ag===u(I(ag)||global.document)}U=(function(){var ag=W;if(r){ag=G}else{if(J){ag=D}}return ag}());function n(al,ah,ak,ai){var aj="addEventListener",ag;al[aj](ah,ak,ai);return ag}function Q(ak,ah,aj,ai){var ag=null;if(U(ak)){ag=n(ak,ah,aj,ai)}ak=null;return ag}function h(ak,ah,aj){var ai="attachEvent",ag;ak[ai]("on"+ah,aj);return ag}function af(aj,ah,ai){var ag=null;if(U(aj)){ag=h(aj,ah,ai)}aj=null;return ag}Y=(function(){var ai="addEventListener",ah="attachEvent",ag=null;if(M(global.window[ai])){ag=Q}else{if(M(global.window[ah])){ag=af}}return ag}());Utils.event.addWindowListener=Y;function b(al,ah,ak,ai){var aj="removeEventListener",ag;al[aj](ah,ak,ai);return ag}function O(ak,ah,aj,ai){var ag=null;if(U(ak)){ag=b(ak,ah,aj,ai)}ak=null;return ag}function t(ak,ah,aj){var ai="detachEvent",ag;ak[ai]("on"+ah,aj);return ag}function ac(aj,ah,ai){var ag=null;if(U(aj)){ag=t(aj,ah,ai)}aj=null;return ag}j=(function(){var ah="removeEventListener",ai="detachEvent",ag=null;if(M(global.window[ah])){ag=O}else{if(M(global.window[ai])){ag=ac}}return ag}());Utils.event.removeWindowListener=j;C={ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCRESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12};function a(ak,ah){var ai=typeof ak,aj=T[ai]&&ak,ag=false;if(aj||ai==="unknown"){ag=ak.nodeType===ah}return ag}function ae(ah){var ag=C.DOCUMENT_NODE;return a(ah,ag)}function aa(ag){return ag===global.document}function q(aj){var ah=typeof aj,ai=T[ah]&&aj,ag=false;if(ai||ah==="unknown"){ag=typeof aj.nodeType==="number"}return ag}z=(function(){var ag=ae;if(!q(k)){ag=aa}return ag}());function F(ak,ah,aj,ai){var ag=null;if(z(ak)){ag=n(ak,ah,aj,ai)}return ag}function c(aj,ah,ai){var ag=null;if(z(aj)){ag=h(aj,ah,ai)}return ag}E=(function(){var ai="addEventListener",ah="attachEvent",ag=null;if(M(k[ai])){ag=F}else{if(M(k[ah])){ag=c}}return ag}());Utils.event.addDocumentListener=E;function S(ak,ah,aj,ai){var ag=null;if(z(ak)){ag=b(ak,ah,aj,ai)}return ag}function p(aj,ah,ai){var ag=null;if(z(aj)){ag=t(aj,ah,ai)}return ag}i=(function(){var ah="removeEventListener",ai="detachEvent",ag=null;if(M(k[ah])){ag=S}else{if(M(k[ai])){ag=p}}return ag}());Utils.event.removeDocumentListener=i;function y(ah){var ag=C.ELEMENT_NODE;return a(ah,ag)}function ab(ak,ah,aj,ai){var ag=null;if(y(ak)){ag=n(ak,ah,aj,ai)}return ag}function v(aj,ah,ai){var ag=null;if(y(aj)){ag=h(aj,ah,ai)}return ag}d=(function(){var ah="documentElement",ag=null;if(M(k[ah])){ag=k[ah]}return ag}());R=(function(){var ai="addEventListener",ah="attachEvent",ag=null;if(d){if(M(d[ai])){ag=ab}else{if(M(d[ah])){ag=v}}}return ag}());Utils.event.addElementListener=R;function N(ak,ah,aj,ai){var ag=null;if(y(ak)){ag=b(ak,ah,aj,ai)}return ag}function Z(aj,ah,ai){var ag=null;if(y(aj)){ag=t(aj,ah,ai)}return ag}w=(function(){var ah="removeEventListener",ai="detachEvent",ag=null;if(d){if(M(d[ah])){ag=N}else{if(M(d[ai])){ag=Z}}}return ag}());Utils.event.removeElementListener=w;function o(ah){var ag=ah;if(M(global.event)){ag=global.event}return ag}Utils.event.getObject=o;function ad(ah){var ai="target",ag=null;if(ah&&M(ah[ai])){ag=ah[ai]}return ag}function L(){var ah="srcElement",ag=null;if(M(global.event[ah])){ag=global.event[ah]}return ag}function B(ah){var ag=ad(ah);if(M(global.event)){ag=L()}return ag}Utils.event.getTarget=B;k=null;d=null}())};